<template>
  <client-only>
    <div class="module module-slider-projekte mobile-fullwidth">
      <atom-slider
        ref="flickity"
        class="main-carousel flickity equal-heights"
        :options="sliderOptions"
        :class="{ loaded: loaded }"
        :auto-init="false"
        @init="loaded = true"
      >
        <div
          v-for="(slide, index) in slides"
          :key="index"
          class="carousel-cell slide"
        >
          <div class="row">
            <div
              class="col-12 col-md-5 col-xl-4 offset-xl-1"
              :class="[
                { 'offset-lg-1': data.imgOrder !== null },
                { 'order-md-2': data.imgOrder !== null },
              ]"
            >
              <nuxt-link
                :to="slide.uri || slide.projekt.uri"
                class="slider-link"
              >
                <div class="img-wrapper">
                  <atom-image
                    v-if="
                      data.customcontent
                        ? slide.projekt.featuredImage
                        : slide.featuredImage
                    "
                    class="slider-image cover"
                    :image="
                      data.customcontent
                        ? slide.projekt.featuredImage.node
                        : slide.featuredImage.node
                    "
                    :ratio="imageRatio"
                    :lazyload="false"
                  />
                </div>
              </nuxt-link>
            </div>
            <div
              class="col-12 col-md-6 col-lg-5 offset-lg-1"
              :class="[
                { 'offset-md-1': data.imgOrder !== null },
                { 'order-md-1': data.imgOrder !== null },
              ]"
            >
              <div class="text-wrapper">
                <nuxt-link
                  :to="slide.uri || slide.projekt.uri"
                  class="slider-link"
                >
                  <span v-if="data.customcontent && slide.projekt.projekt.dachzeile" class="dachzeile">
                    {{ slide.projekt.projekt.dachzeile }}
                  </span>
                  <span v-else-if="!data.customcontent && slide.projekt.dachzeile" class="dachzeile">
                     {{ slide.projekt.dachzeile }}
                  </span>
                  <h2 class="small">
                    {{ slide.title || slide.projekt.title }}
                  </h2>
                  <p
                    v-html="
                      slide.projekt.teaser || slide.projekt.projekt.teaser
                    "
                  ></p>
                  <span class="link d-none d-lg-block">Alles zum Projekt</span>
                </nuxt-link>
              </div>
            </div>
          </div>
        </div>
      </atom-slider>
      <div v-if="isMobile" class="flickity-mobile-controls">
        <button
          class="flickity-button flickity-prev-next-button previous"
          type="button"
          aria-label="Previous"
          @click="$refs.flickity.previous()"
        >
          <svg
            xmlns="http://www.w3.org/2000/svg"
            viewBox="0 0 48 23"
            style="enable-background: new 0 0 48 23"
            xml:space="preserve"
          >
            <path d="m35.6 0-2 2 8.3 8.3H-1v2.8h42.5L33.6 21l2 2L47 11.5z" />
          </svg>
        </button>
        <ol class="flickity-page-dots">
          <li
            v-for="(slide, index) in slides"
            :key="index"
            class="dot"
            :class="{ 'is-selected': selectedSlide === index }"
            @click="$refs.flickity.select(index)"
          ></li>
        </ol>
        <button
          class="flickity-button flickity-prev-next-button next"
          type="button"
          aria-label="Next"
          @click="$refs.flickity.next()"
        >
          <svg
            xmlns="http://www.w3.org/2000/svg"
            viewBox="0 0 48 23"
            style="enable-background: new 0 0 48 23"
            xml:space="preserve"
          >
            <path d="m35.6 0-2 2 8.3 8.3H-1v2.8h42.5L33.6 21l2 2L47 11.5z" />
          </svg>
        </button>
      </div>
      <button
        v-if="!isMobile"
        class="
          flickity-button
          flickity-prev-next-button
          flickity-prev-next-button-desktop
          previous
        "
        type="button"
        aria-label="Previous"
        @click="$refs.flickity.previous()"
      >
        <svg class="flickity-button-icon" viewBox="0 0 100 100">
          <path
            d="M79.6 8.8 70.4 0l-50 50 50 50 9.2-8.8L38.3 50z"
            class="arrow"
          ></path>
        </svg>
      </button>
      <button
        v-if="!isMobile"
        class="
          flickity-button
          flickity-prev-next-button
          flickity-prev-next-button-desktop
          next
        "
        type="button"
        aria-label="Next"
        @click="$refs.flickity.next()"
      >
        <svg class="flickity-button-icon" viewBox="0 0 100 100">
          <path
            d="M79.6 8.8 70.4 0l-50 50 50 50 9.2-8.8L38.3 50z"
            class="arrow"
            transform="translate(100, 100) rotate(180) "
          ></path>
        </svg>
      </button>
    </div>
  </client-only>
</template>

<script>
import allProjekte from "~/apollo/queries/allProjekte";

export default {
  props: {
    data: {
      type:Object,
      default: () => {},
    }
  },
  data() {
    return {
      loaded: false,
      selectedSlide: 0,
      projekte: [],
      impulsprojekte: []
    };
  },
  async fetch() {
    if (!this.data.customcontent) {
      const client = this.$nuxt.$apolloProvider.defaultClient;

      await client.query({
        query: allProjekte,
      }).then((result) => {
        this.projekte = result.data.projekte.nodes;
        this.impulsprojekte = result.data.impulsprojekte.nodes;
      }).catch((err) => {
        console.log(err); // eslint-disable-line
      });
    }
  },
  computed: {
    isMobile() {
      return this.$mq === 'sm' || this.$mq === 'xs';
    },
    impulsprojekteComputed() {
      return this.impulsprojekte.filter(projekt => projekt.uri !== this.$route.path);
    },
    projekteComputed() {
      return this.projekte.filter(projekt => projekt.uri !== this.$route.path);
    },
    slides() {
      if (!this.data.customcontent) {
        return this.data.type === 'projekt' ? this. projekteComputed : this.impulsprojekteComputed;
      }

      return this.data.slides;
    },
    sliderOptions() {
      return {
          wrapAround: true,
          cellAlign: 'left',
          autoPlay: false,
          contain: true,
          selectedAttraction: 0.025,
          friction: 0.3,
          pageDots: false,
          prevNextButtons: false,
          adaptiveHeight: this.$mq === 'sm' || this.$mq === 'xs' || this.$mq === 'md',
          arrowShape: 'M79.6 8.8 70.4 0l-50 50 50 50 9.2-8.8L38.3 50z',
          // any options from Flickity can be used
      }
    },
    imageRatio() {
      return this.isMobile ? '1x1' : '9x13';
    },
  },
  watch: {
    slides: {
      deep: true,
      handler() {
        this.$nextTick(() => {
            if (this.$refs.flickity) {
              this.$refs.flickity.rerender();

              this.$refs.flickity.on('change', (index) => {
                this.selectedSlide = index;
              });
            }
        });
      },
    },
  },
  mounted() {
    if (this.data.customcontent) {
      this.$nextTick(() => {
        if (this.$refs.flickity) {
            this.$refs.flickity.rerender();

            this.$refs.flickity.on('change', (index) => {
              this.selectedSlide = index;
            });
          }
      });
    }
  },
};
</script>

<style lang="scss">
.module-slider-projekte {
  padding: 0;

  .slider-link {
    text-decoration: none;

    &:hover {
      color: inherit;
    }
  }

  .text-wrapper {
    @include media-breakpoint-down(sm) {
      margin-top: 2rem;
      height: calc(100% - 3rem);
    }

    @include media-breakpoint-up(md) {
      min-height: 200px;
    }

    @include media-breakpoint-up(lg) {
      min-height: none;
    }


    p {
      font-weight: 300;
      margin-bottom: 0;
    }

    .link {
      display: block;
      font-weight: 600;
      text-transform: uppercase;
      letter-spacing: 1px;
      margin-top: 2rem;
    }
  }

  .flickity-viewport {
    transition: height 0.35s;
  }
}
</style>
